=== debian/changelog ===
ros-foxy-pinocchio (2.6.17-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Justin Carpentier <justin.carpentier@inria.fr>  Wed, 15 Feb 2023 20:45:06 -0000
