=== debian/control ===
Source: ros-foxy-pinocchio
Section: misc
Priority: optional
Maintainer: Justin Carpentier <justin.carpentier@inria.fr>
Build-Depends: debhelper (>= 9.0.0), clang, cmake, doxygen, git, libboost-all-dev, libeigen3-dev, liburdfdom-dev, python3-dev, python3-numpy, ros-foxy-eigenpy, ros-foxy-hpp-fcl, ros-foxy-ros-workspace
Homepage: https://github.com/stack-of-tasks/pinocchio
Standards-Version: 3.9.2

Package: ros-foxy-pinocchio
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libeigen3-dev, liburdfdom-dev, python3-dev, python3-numpy, ros-foxy-eigenpy, ros-foxy-hpp-fcl, ros-foxy-ros-workspace
Description: A fast and flexible implementation of Rigid Body Dynamics algorithms and their analytical derivatives.
